<!-- DataTables -->
<link rel="stylesheet"
	  href="<?= base_url('<link rel="stylesheet" 
	href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap.min.css">') ?>">
<link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css"/>
<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/buttons/1.6.2/css/buttons.dataTables.min.css">
<link rel="stylesheet" href="<?= base_url('bower_components/toastr/toastr.css') ?>">
<div class="content-wrapper">
<?php

use Brick\Money\Context\AutoContext;
use Brick\Money\CurrencyConverter;
use Brick\Money\ExchangeRateProvider\BaseCurrencyProvider;
use Brick\Money\ExchangeRateProvider\PDOProvider;
use Brick\Money\ExchangeRateProvider\PDOProviderConfiguration;

?>
	<!-- Content Header (Page header) -->
	<section class="content-header">

		<h1>
			<?= isset($category) ? 'Wallet' :  $this->lang->line('Gestion des wallets') ; echo ' '.$network.' - '.$country
			.' :: '.$this->lang->line('Historique des transactions'); ?>
<!--			<input type="button" class="btn btn-primary pull-right" id="Bactiver"-->
<!--				   value="Activer/Désactiver le(s) réseau(x)" />-->
		</h1>
		<?php
		$site_url = base_url();

		if ($alert == "ok") {

			if (!$success == "ok") {
				?>
				<div class='alert alert-danger alert-dismissible col-xs-6'>
					<button type='button' class='close' data-dismiss='alert' aria-hidden='true'>×</button>
					<h4><i class='icon fa fa-ban'></i> Erreur!</h4>
					<?= $message; ?>
				</div>

				<?php
			} else {
				?>
				<div class="alert alert-success alert-dismissible col-xs-6">
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
					<h4><i class="icon fa fa-check"></i> Success!</h4>
					<?= $message; ?>
				</div>

				<?php
			}
		}
		// set to whatever your rates are relative to
		$baseCurrency = 'USD';

		// use your own credentials, or re-use your existing PDO connection
		$pdo = new PDO('mysql:host=' . $this->db->hostname . ';dbname=' . $this->db->database, $this->db->username, $this->db->password);

		$configuration = new PDOProviderConfiguration();

		$configuration->tableName = 'exchange_rate';
		$configuration->exchangeRateColumnName = 'exchange_rate';
		$configuration->targetCurrencyColumnName = 'target_currency';
		$configuration->sourceCurrencyCode = $baseCurrency;

		// this provider loads exchange rates from your database
		$provider = new PDOProvider($pdo, $configuration);

		// this provider calculates exchange rates relative to the base currency
		$provider = new BaseCurrencyProvider($provider, $baseCurrency);

		// this currency converter can now handle any currency pair
		$converter = new CurrencyConverter($provider);
		$context = new AutoContext();
		?>
	</section>
	<section class="content">
		<div class="row">
			<div class="col-md-4 col-sm-6 col-xs-12">
				<div class="info-box">
					<span class="info-box-icon bg-aqua"><i class="ion ion-android-time"></i></span>
					<div class="info-box-content">
						<span class="info-box-text"><?= $this->lang->line('Période') ?> </span>
						<span class="info-box-number">
                                    <input id="picker"
										   style="background: #fff; cursor: pointer; padding: 1px 1px; border: 1px solid #ccc; width: 100%"
										   data-category="<?= isset($category) ? $category : null ?>"
										   type="text" name="daterange"
										   data-lang="<?= $this->session->userdata('site_lang') ?>"
										   value="<?= ($startDate != null & $endDate != null) ? $startDate . ' - ' . $endDate : '' ?>"/>
                                    
						</span>
						<span> Format : <?= $this->session->userdata('site_lang') === 'french' ? 'Jour - Mois - Année ' : 'Year - Month - Day' ?> </span>
					</div>
				</div>
			</div>

			<div class="col-lg-2 col-xs-6">
				<div class="small-box bg-red-active">
					<div class="inner">
						<h4>
							<strong> <?= $this->session->userdata('currency_code') ? $this->session->userdata('currency_code') : $currency_code
										. ' - ' . $currency_name_fr; ?> </strong>
						</h4>
						<p><?= $this->lang->line('currency') ?></p>
					</div>
				</div>
			</div>

		</div>
		<div class="row">
			<div class="col-xs-12">
				<div class="box">
					<div class="box-header">
						<h3 class="box-title"><?= $this->lang->line('export_transaction_history') ?></h3>
					</div>
					<div class="box-body" style="overflow-x:auto;">

						<table id="transactions" class="table table-bordered table-striped">
							<thead>
							<tr>
								<th align='center'>ID</th>
								<th align='center'>Operation</th>
								<th><?= $this->lang->line('cart_number') ?></th>
								<th><?= $this->lang->line('customer_net_amount_init') ?></th>
								<th><?= $this->lang->line('customer_net_amount_final') ?></th>
								<th><?= $this->lang->line('commission_paying_network') ?></th>
								<th><?= $this->lang->line('status_with_paying_network') ?></th>
								<th><?= $this->lang->line('final_currency') ?></th>
								<th><?= $this->lang->line('departure_country') ?></th>
								<th><?= $this->lang->line('country_of_destination') ?></th>
								<th><?= $this->lang->line('fees') ?></th>
								<th><?= $this->lang->line('tax') ?></th>
								<th><?= $this->lang->line('Commission de la banque') ?></th>
								<th><?= $this->lang->line('Commission de l\'hyperviseur') ?></th>
								<th><?= $this->lang->line('Commission du superviseur') ?></th>
								<th><?= $this->lang->line('Commission de l\'agent') ?></th>
								<th><?= $this->lang->line('agent_name') ?></th>
								<th><?= $this->lang->line('issuer_id') ?></th>
								<th><?= $this->lang->line('recipient_id')?></th>
								<th align='center'>Date</th>
							</tr>
							</thead>
						</table>
					</div>
				</div>
			</div>
		</div>
	</section>


</div>
<!-- jQuery 2.2.4 -->
<script src="https://code.jquery.com/jquery-2.2.4.min.js"></script>

<!-- Bootstrap 3.3.7 -->
<script src="<?= base_url('bower_components/bootstrap/dist/js/bootstrap.min.js') ?>"></script>
<!-- DataTables -->
<script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap.min.js"></script>
<!-- SlimScroll -->
<script src="<?= base_url('bower_components/jquery-slimscroll/jquery.slimscroll.min.js') ?>"></script>
<!-- FastClick -->
<script src="<?= base_url('bower_components/fastclick/lib/fastclick.js') ?>"></script>
<!-- AdminLTE App -->
<script src="<?= base_url('dist/js/adminlte.min.js') ?>"></script>
<!-- AdminLTE for demo purposes -->
<script src="<?= base_url('dist/js/demo.js') ?>"></script>

<script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment-with-locales.min.js"></script>
<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/plug-ins/1.10.19/sorting/datetime-moment.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/plug-ins/1.10.20/dataRender/datetime.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/buttons/1.6.2/js/dataTables.buttons.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/pdfmake.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/vfs_fonts.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/buttons/1.6.2/js/buttons.html5.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/buttons/1.6.2/js/buttons.print.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/buttons/1.6.2/js/buttons.colVis.min.js"></script>
<script src="<?= base_url('dist/js/sweetalert2.js') ?>"></script>
<script src="<?= base_url('bower_components/toastr/toastr.js') ?>"></script>


<script>
	$(function () {
		const lang = $('#picker').data('lang');
		const format = lang === 'french' ? 'fr' : 'en';
		moment.updateLocale(moment.locale(format), {invalidDate: ""}); // Blank text when is invalid date

		var table = $('#transactions').DataTable({
			// Processing indicator
			"processing": true,
			"language": {
				"processing": "<?= $this->lang->line('loading') ?>",
				"emptyTable" : "<?= $this->lang->line('Aucune transaction') ?>"
			},
			// DataTables server-side processing mode
			"serverSide": true,
			// Initial no order.
			"order": [],
			// Load data from an Ajax source
			"ajax": {
				"url": "<?= base_url('pagination/WalletIlinkTransaction/getLists'); ?>",
				"data":{
					"startDate" : "<?= $startDate?>",
					"endDate" : "<?= $endDate?>",
					"id_network" : <?= $id_network ?>
				},
				"type": "POST"
			},
			"aaSorting": [[19, "desc"]],
			"columnDefs": [{
				"targets": [19],
				// "orderable": false,
				render: $.fn.dataTable.render.moment('YYYY-MM-DD HH:mm:ss', 'D MMMM YYYY HH:mm:ss', format)
			}],
			dom: 'Bfrtip',
			"buttons": [
				'pageLength',
				{
					"extend": 'excelHtml5',
					title: "<?= $this->lang->line('Historique des transactions') ?>",
					// exportOptions: {
					// 	columns: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17]
					// },
					customizeData: function (data) {
						for (var i = 0; i < data.body.length; i++) {
							for (var j = 0; j < data.body[i].length; j++) {
								// data.body[i][j] = '\u200C' + data.body[i][j];
								if ([3, 4, 5, 10, 11, 12, 13, 14,15].includes(j)) {
									// Get the value and strip the non numeric characters
									// var value = $(this).text();
									value = data.body[i][j].replace(',', ".")
									data.body[i][j] = Number(value.replace(/[^0-9\.-]+/g, ""));
								}
							}
						}
					},
					trim: false,
					"action": newexportaction
				},
				{
					extend: 'csvHtml5',
					title: "<?= $this->lang->line('Historique des transactions') ?>",
					exportOptions: {
						columns: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17]
					},
					customizeData: function (data) {
						for (var i = 0; i < data.body.length; i++) {
							for (var j = 0; j < data.body[i].length; j++) {
								// data.body[i][j] = '\u200C' + data.body[i][j];
								if ([3, 4, 5, 10, 11, 12, 13, 14,15].includes(j)) {
									// Get the value and strip the non numeric characters
									// var value = $(this).text();
									value = data.body[i][j].replace(',', ".")
									data.body[i][j] = Number(value.replace(/[^0-9\.-]+/g, ""));
								}
							}
						}
					},
					trim: false,
					"action": newexportaction
				},
				{
					extend: 'pdfHtml5',
					orientation: 'landscape',
					pageSize: 'LEGAL',
					title: "<?= $this->lang->line('Historique des transactions') ?>",
					exportOptions: {
						columns: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17]
					},
					trim: false,
					"action": newexportaction
				},
				// 'colvis'
			]
		});

		table.buttons().container()
				.appendTo('#example_wrapper .col-sm-6:eq(0)');

		function newexportaction(e, dt, button, config) {
			var self = this;
			var oldStart = dt.settings()[0]._iDisplayStart;
			dt.one('preXhr', function (e, s, data) {
				// Just this once, load all data from the server...
				data.start = 0;
				data.length = 2147483647;
				dt.one('preDraw', function (e, settings) {
					// Call the original action function
					if (button[0].className.indexOf('buttons-copy') >= 0) {
						$.fn.dataTable.ext.buttons.copyHtml5.action.call(self, e, dt, button, config);
					} else if (button[0].className.indexOf('buttons-excel') >= 0) {
						$.fn.dataTable.ext.buttons.excelHtml5.available(dt, config) ?
								$.fn.dataTable.ext.buttons.excelHtml5.action.call(self, e, dt, button, config) :
								$.fn.dataTable.ext.buttons.excelFlash.action.call(self, e, dt, button, config);
					} else if (button[0].className.indexOf('buttons-csv') >= 0) {
						$.fn.dataTable.ext.buttons.csvHtml5.available(dt, config) ?
								$.fn.dataTable.ext.buttons.csvHtml5.action.call(self, e, dt, button, config) :
								$.fn.dataTable.ext.buttons.csvFlash.action.call(self, e, dt, button, config);
					} else if (button[0].className.indexOf('buttons-pdf') >= 0) {
						$.fn.dataTable.ext.buttons.pdfHtml5.available(dt, config) ?
								$.fn.dataTable.ext.buttons.pdfHtml5.action.call(self, e, dt, button, config) :
								$.fn.dataTable.ext.buttons.pdfFlash.action.call(self, e, dt, button, config);
					} else if (button[0].className.indexOf('buttons-print') >= 0) {
						$.fn.dataTable.ext.buttons.print.action(e, dt, button, config);
					}
					dt.one('preXhr', function (e, s, data) {
						// DataTables thinks the first item displayed is index 0, but we're not drawing that.
						// Set the property to what it was before exporting.
						settings._iDisplayStart = oldStart;
						data.start = oldStart;
					});
					// Reload the grid with the original page. Otherwise, API functions like table.cell(this) don't work properly.
					setTimeout(dt.ajax.reload, 0);
					// Prevent rendering of the full data to the DOM
					return false;
				});
			});
			// Requery the server with the new one-time export settings
			dt.ajax.reload();
		}
	});
</script>

<script type="text/javascript">
	var startDate;
	var endDate;

	$(function () {
		const lang =  $('#picker').data('lang');
		const category =  $('#picker').data('category');
        const id_network = "<?= $id_network?>";
        $('input[name="daterange"]').daterangepicker({
			opens: 'left',
			autoUpdateInput: false,
			locale: {
				format: lang === 'french' ? 'DD-MM-YYYY' : 'YYYY-MM-DD',
				cancelLabel: 'Clear'
			}
		}, function (start, end, label) {
			const debut = start.format('YYYY-MM-DD');
			const fin = end.format('YYYY-MM-DD');
			if(category)
				window.location = "<?= current_url()?>" + "?history=transaction_ilink" + "&d=" + debut + "&f=" + fin;
			else
				window.location = "<?= current_url()?>" + "?id="+id_network+"&history=transaction_ilink" + "&d=" + debut + "&f=" + fin;

		});

		$('input[name="daterange"]').on('cancel.daterangepicker', function(ev, picker) {
			//do something, like clearing an input
			$('#daterange').val('');
			if(category)
				window.location = "<?= current_url()?>" + "?history=transaction_ilink";
			else
				window.location = "<?= current_url()?>" + "?id="+id_network+"&history=transaction_ilink";
		});
	});

</script>
<script>
	$(document).on("click", "#cancel", function () {
		const id_transaction = $(this).data('id-transaction');
		$.ajax({
			url : '<?= base_url('Gestion/cancelIlinkTransation')?>',
			type : 'POST',
			dataType : 'json',
			data: {"id_transaction": id_transaction},
			async:true,
			success : function(data){
				if(data){
					Swal.fire({
						icon: 'success',
						title: "<?= $this->lang->line('canceled_transaction')?>",
						text: "<?= $this->lang->line('informations_updated')?>",
						timer: 3000
					}).then(()=>{
						location.reload();
					});
					// alert("Les informations ont été mises à jour.") ? "" : location.reload();
				}else{
					toastr.error("<?= $this->lang->line('error_message')?>" , "<?= $this->lang->line('request_error')?>");
				}
			},

			error : function(resultat, statut, erreur){
				console.log(resultat+" "+erreur);
				toastr.error("<?= $this->lang->line('error_message')?>" , "<?= $this->lang->line('request_error')?>");
			}
		});
	});
</script>
